Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Interface Searchable

All Superinterfaces:
  Remote

All Known Implementing Classes:
  IndexSearcher, MultiSearcher, ParallelMultiSearcher, RemoteSearchable, Searcher

    public interface Searchable

extends Remote

The interface for search implementations.

Searchable is the abstract network protocol for searching. Implementations provide search over a single index, over multiple indices, and over indices on remote servers.

Queries, filters and sort criteria are designed to be compact so that they may be efficiently passed to a remote index, with only the top-scoring hits being returned, rather than every matching hit.

Method Summary
`void` | `close()` Frees resources associated with this Searcher.
`Document` | `doc(int i)` Expert: Returns the stored fields of document `i`.
`Document` | `doc(int n, FieldSelector fieldSelector)` Get the `Document` at the `n`th position.
`int` | `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
`int[]` | `docFreqs(Term[] terms)` Expert: For each term in the terms array, calculates the number of documents containing `term`.
`Explanation` | `explain(Weight weight, int doc)` Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.
`int` | `maxDoc()` Expert: Returns one greater than the largest possible document number.
`Query` | `rewrite(Query query)` Expert: called to re-write queries into primitive queries.
`void` | `search(Weight weight, Filter filter, HitCollector results)` Lower-level search API.
`TopDocs` | `search(Weight weight, Filter filter, int n)` Expert: Low-level search implementation.
`TopFieldDocs` | `search(Weight weight, Filter filter, int n, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.

Method Detail

### search

    void search(Weight weight,
                Filter filter,
                HitCollector results)
                throws IOException

  Lower-level search API.

  `HitCollector.collect(int,float)` is called for every non-zero scoring document.
  HitCollector-based access to remote indexes is discouraged.

  Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

  Parameters:
    `weight` - to match documents
    `filter` - if non-null, used to permit documents to be collected.
    `results` - to receive hits
  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### close

    void close()
               throws IOException

  Frees resources associated with this Searcher. Be careful not to call this method while you are still using objects like `Hits`.

  Throws:
    `IOException`

### docFreq

    int docFreq(Term term)
                throws IOException

  Expert: Returns the number of documents containing `term`. Called by search code to compute term weights.

  Throws:
    `IOException`
  See Also:
    `IndexReader.docFreq(Term)`

### docFreqs

    int[] docFreqs(Term[] terms)
                   throws IOException

  Expert: For each term in the terms array, calculates the number of documents containing `term`. Returns an array with these document frequencies. Used to minimize number of remote calls.

  Throws:
    `IOException`

### maxDoc

    int maxDoc()
               throws IOException

  Expert: Returns one greater than the largest possible document number. Called by search code to compute term weights.

  Throws:
    `IOException`
  See Also:
    `IndexReader.maxDoc()`

### search

    TopDocs search(Weight weight,
                   Filter filter,
                   int n)
                   throws IOException

  Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

  Called by `Hits`.

  Applications should usually call `Searcher.search(Query)` or `Searcher.search(Query,Filter)` instead.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### doc

    Document doc(int i)
                 throws CorruptIndexException,
                        IOException

  Expert: Returns the stored fields of document `i`. Called by `HitCollector` implementations.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `IndexReader.document(int)`

### doc

    Document doc(int n,
                 FieldSelector fieldSelector)
                 throws CorruptIndexException,
                        IOException

  Get the `Document` at the `n`th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If the underlying Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

  Parameters:
    `n` - Get the document at the `n`th position
    `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
  Returns:
    The stored fields of the `Document` at the nth position
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `IndexReader.document(int, FieldSelector)`, `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

### rewrite

    Query rewrite(Query query)
                  throws IOException

  Expert: called to re-write queries into primitive queries.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### explain

    Explanation explain(Weight weight,
                        int doc)
                        throws IOException

  Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Applications should call `Searcher.explain(Query, int)`.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    TopFieldDocs search(Weight weight,
                        Filter filter,
                        int n,
                        Sort sort)
                        throws IOException

  Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  Applications should usually call `Searcher.search(Query,Filter,Sort)` instead.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.